## xdp-tools 1.5.7

=== Makefile ===

# SPDX-License-Identifier: GPL-2.0
# Top level Makefile for xdp-tools

ifeq ("$(origin V)", "command line")
VERBOSE = $(V)
endif
ifndef VERBOSE
VERBOSE = 0
endif

ifeq ($(VERBOSE),0)
MAKEFLAGS += --no-print-directory
endif

include version.mk
include config.mk

UTILS := xdp-filter xdp-loader xdp-dump

ifneq ($(BPFTOOL),)
UTILS += xdp-bench xdp-forward xdp-monitor xdp-trafficgen
endif

SUBDIRS := lib $(UTILS)
.PHONY: check_submodule help clobber distclean clean install test libxdp $(SUBDIRS)

all: $(SUBDIRS)

lib: config.mk check_submodule
	@echo; echo $@; $(MAKE) -C $@

libxdp: config.mk check_submodule
	@echo; echo lib; $(MAKE) -C lib $@

libxdp_install: libxdp
	@$(MAKE) -C lib $@

$(UTILS): lib
	@echo; echo $@; $(MAKE) -C $@

help:
	@echo "Make Targets:"
	@echo " all                 - build binaries"
	@echo " clean               - remove products of build"
	@echo " distclean           - remove configuration and build"
	@echo " install             - install binaries on local machine"
	@echo " test                - run test suite"
	@echo " archive             - create tarball of all sources"
	@echo ""
	@echo "Make Arguments:"
	@echo " V=[0|1]             - set build verbosity level"

config.mk: configure
	sh configure

check_submodule:
	@if [ -d .git ] && `git submodule status lib/libbpf | grep -q '^+'`; then \
		echo "" ;\
		echo "** WARNING **: git submodule SHA-1 out-of-sync" ;\
		echo " consider running: git submodule update"  ;\
		echo "" ;\
	fi\

clobber:
	touch config.mk
	$(MAKE) clean
	rm -f config.mk cscope.* compile_commands.json

distclean: clobber

clean: check_submodule
	@for i in $(SUBDIRS); \
	do $(MAKE) -C $$i clean; done

install: all
	@for i in $(SUBDIRS); \
	do $(MAKE) -C $$i install; done

test: all
	@for i in lib/libxdp $(UTILS); do \
		echo; echo test $$i; $(MAKE) -C $$i test; \
		if [ $$? -ne 0 ]; then failed="y"; fi; \
	done; \
	if [ ! -z $$failed ]; then exit 1; fi


archive: xdp-tools-$(TOOLS_VERSION).tar.gz

.PHONY: xdp-tools-$(TOOLS_VERSION).tar.gz
xdp-tools-$(TOOLS_VERSION).tar.gz:
	@./mkarchive.sh "$(TOOLS_VERSION)"

compile_commands.json: clean
	compiledb make V=1

=== lib/Makefile ===

LIBBPF_CFLAGS:=$(if $(CFLAGS),$(CFLAGS),-g -O2 -Werror -Wall) -fPIC

LIB_DIR = .
include defines.mk

SUBDIRS=util testing
.PHONY: $(SUBDIRS)

all: $(SUBDIRS) libxdp

util: libxdp
	@echo; echo "  $@"; $(MAKE) -C $@

testing: libxdp util
	@echo; echo "  $@"; $(MAKE) -C $@

.PHONY: libxdp
libxdp: $(OBJECT_LIBBPF)
	@echo; echo "  $@"; $(MAKE) -C $@

.PHONY: clean
clean: libbpf_clean
	@for i in $(SUBDIRS) libxdp; \
	do $(MAKE) -C $$i clean; done

.PHONY: install
install: libxdp_install
	$(MAKE) -C testing install

.PHONY: libxdp_install
libxdp_install: libxdp
	install -m 0755 -d $(DESTDIR)$(HDRDIR)
	$(MAKE) -C libxdp install

libbpf: $(OBJECT_LIBBPF)

# Handle libbpf as git submodule
ifeq ($(SYSTEM_LIBBPF),n)
ifeq ($(VERBOSE),0)
P:= >/dev/null
endif

# Detect submodule libbpf source file changes
LIBBPF_SOURCES := $(wildcard libbpf/src/*.[ch])

.PHONY: libbpf_clean
libbpf/src/libbpf.a: $(LIBBPF_SOURCES)
	@echo ; echo "  libbpf"
	$(QUIET_CC)$(MAKE) -C libbpf/src CFLAGS="$(LIBBPF_CFLAGS)" $P
	$(QUIET_INSTALL)$(MAKE) -C libbpf/src install_headers DESTDIR=root PREFIX=/ $P

libbpf_clean:
	$(Q)$(MAKE) -C libbpf/src clean $P

else

libbpf_clean:
	@echo -n
endif

=== xdp-bench/Makefile ===
# SPDX-License-Identifier: (GPL-2.0 OR BSD-2-Clause)

XDP_TARGETS := xdp_redirect_basic.bpf xdp_redirect_cpumap.bpf xdp_redirect_devmap.bpf \
	       xdp_redirect_devmap_multi.bpf xdp_basic.bpf
BPF_SKEL_TARGETS := $(XDP_TARGETS)

# Don't install skeleton object files
XDP_OBJ_INSTALL :=

TOOL_NAME := xdp-bench
MAN_PAGE := xdp-bench.8
TEST_FILE := tests/test-xdp-bench.sh
USER_TARGETS := xdp-bench
USER_EXTRA_C := xdp_redirect_basic.c xdp_redirect_cpumap.c xdp_redirect_devmap.c \
		xdp_redirect_devmap_multi.c xdp_basic.c
EXTRA_USER_DEPS := xdp-bench.h

LIB_DIR       = ../lib

include $(LIB_DIR)/common.mk

=== xdp-forward/Makefile ===
# SPDX-License-Identifier: GPL-2.0

XDP_TARGETS := xdp_forward.bpf xdp_flowtable.bpf xdp_flowtable_sample.bpf
BPF_SKEL_TARGETS := $(XDP_TARGETS)

XDP_OBJ_INSTALL :=

TOOL_NAME := xdp-forward
MAN_PAGE := xdp-forward.8
TEST_FILE := tests/test-xdp-forward.sh
USER_TARGETS := xdp-forward

LIB_DIR := ../lib

include $(LIB_DIR)/common.mk

=== xdp-monitor/Makefile ===
# SPDX-License-Identifier: (GPL-2.0 OR BSD-2-Clause)

XDP_TARGETS := xdp_monitor.bpf
BPF_SKEL_TARGETS := $(XDP_TARGETS)

# Don't install skeleton object files
XDP_OBJ_INSTALL :=

TOOL_NAME := xdp-monitor
MAN_PAGE := xdp-monitor.8
TEST_FILE := tests/test-xdp-monitor.sh
USER_TARGETS := xdp-monitor
LIB_DIR       = ../lib

include $(LIB_DIR)/common.mk

=== lib/libxdp/Makefile ===
# SPDX-License-Identifier: (GPL-2.0 OR BSD-2-Clause)

LIB_DIR = ..

include libxdp.mk
include $(LIB_DIR)/defines.mk

OBJDIR ?= .
SHARED_OBJDIR := $(OBJDIR)/sharedobjs
STATIC_OBJDIR := $(OBJDIR)/staticobjs
OBJS := libxdp.o xsk.o
XDP_OBJS := xdp-dispatcher.o xsk_def_xdp_prog.o xsk_def_xdp_prog_5.3.o
EMBEDDED_XDP_OBJS := $(addsuffix .embed.o,$(basename $(XDP_OBJS)))
SHARED_OBJS := $(addprefix $(SHARED_OBJDIR)/,$(OBJS))
STATIC_OBJS := $(addprefix $(STATIC_OBJDIR)/,$(OBJS)) $(EMBEDDED_XDP_OBJS)
STATIC_LIBS := $(OBJDIR)/libxdp.a
MAN_PAGE := libxdp.3
MAN_OBJ := ${MAN_PAGE:.3=.man}
MAN_FILES := $(MAN_PAGE)
TEST_DIR := tests

SHARED_CFLAGS += -fPIC -DSHARED
STATIC_CFLAGS += -D LIBXDP_STATIC=1
LIB_HEADERS := $(wildcard $(HEADER_DIR)/xdp/*.h)
BPF_HEADERS := $(wildcard $(HEADER_DIR)/bpf/*.h) $(wildcard $(HEADER_DIR)/xdp/*.h)
EXTRA_LIB_DEPS := $(OBJECT_LIBBPF) $(LIBMK) $(LIB_OBJS) $(LIB_HEADERS) compat.h libxdp_internal.h xsk_def_xdp_prog.h bpf_instr.h
PC_FILE := $(OBJDIR)/libxdp.pc
TEMPLATED_SOURCES := xdp-dispatcher.c

CFLAGS += -I$(HEADER_DIR)
BPF_CFLAGS += -I$(HEADER_DIR) $(ARCH_INCLUDES)


ifndef BUILD_STATIC_ONLY
SHARED_LIBS := $(OBJDIR)/libxdp.so \
	       $(OBJDIR)/libxdp.so.$(LIBXDP_MAJOR_VERSION) \
	       $(OBJDIR)/libxdp.so.$(LIBXDP_VERSION)
VERSION_SCRIPT := libxdp.map
CHECK_RULES := check_abi
endif

all: $(STATIC_LIBS) $(SHARED_LIBS) $(XDP_OBJS) $(PC_FILE) check man build_tests

.PHONY: clean
clean:
	$(Q)rm -f $(STATIC_LIBS) $(STATIC_OBJS) $(SHARED_LIBS) $(SHARED_OBJS) $(XDP_OBJS) $(PC_FILE) $(MAN_OBJ) $(TEMPLATED_SOURCES) *.ll
	$(Q)for d in $(SHARED_OBJDIR) $(STATIC_OBJDIR); do \
		[ -d "$$d" ] && rmdir "$$d"; done || true
	$(Q)$(MAKE) -C $(TEST_DIR) clean

.PHONY: install
install: all
	$(Q)install -d -m 0755 $(DESTDIR)$(HDRDIR)
	$(Q)install -d -m 0755 $(DESTDIR)$(LIBDIR)
	$(Q)install -d -m 0755 $(DESTDIR)$(LIBDIR)/pkgconfig
	$(Q)install -d -m 0755 $(DESTDIR)$(BPF_OBJECT_DIR)
	$(Q)install -m 0644 $(LIB_HEADERS) $(DESTDIR)$(HDRDIR)/
	$(Q)install -m 0644 $(PC_FILE) $(DESTDIR)$(LIBDIR)/pkgconfig/
	$(Q)cp -fpR $(SHARED_LIBS) $(STATIC_LIBS) $(DESTDIR)$(LIBDIR)
	$(Q)install -m 0644 $(XDP_OBJS) $(DESTDIR)$(BPF_OBJECT_DIR)
	$(if $(MAN_FILES),$(Q)install -m 0755 -d $(DESTDIR)$(MANDIR)/man3)
	$(if $(MAN_FILES),$(Q)install -m 0644 $(MAN_FILES) $(DESTDIR)$(MANDIR)/man3)
	$(Q)$(MAKE) -C $(TEST_DIR) install


$(OBJDIR)/libxdp.a: $(STATIC_OBJS)
	$(QUIET_LINK)$(AR) rcs $@ $^

$(OBJDIR)/libxdp.so: $(OBJDIR)/libxdp.so.$(LIBXDP_MAJOR_VERSION)
	$(Q)ln -sf $(^F) $@

$(OBJDIR)/libxdp.so.$(LIBXDP_MAJOR_VERSION): $(OBJDIR)/libxdp.so.$(LIBXDP_VERSION)
	$(Q)ln -sf $(^F) $@

$(OBJDIR)/libxdp.so.$(LIBXDP_VERSION): $(SHARED_OBJS)
	$(QUIET_LINK)$(CC) -shared -Wl,-soname,libxdp.so.$(LIBXDP_MAJOR_VERSION) \
		      -Wl,--version-script=$(VERSION_SCRIPT) \
		      $^ $(LDFLAGS) $(LDLIBS) -o $@

$(OBJDIR)/libxdp.pc:
	$(Q)sed -e "s|@PREFIX@|$(PREFIX)|" \
			-e "s|@LIBDIR@|$(LIBDIR)|" \
			-e "s|@VERSION@|$(TOOLS_VERSION)|" \
			< libxdp.pc.template > $@

$(STATIC_OBJDIR):
	$(Q)mkdir -p $(STATIC_OBJDIR)

$(SHARED_OBJDIR):
	$(Q)mkdir -p $(SHARED_OBJDIR)

$(STATIC_OBJDIR)/%.o: %.c $(EXTRA_LIB_DEPS) | $(STATIC_OBJDIR)
	$(QUIET_CC)$(CC) $(CFLAGS) $(CPPFLAGS) $(STATIC_CFLAGS) -Wall -I../../headers -c $< -o $@

$(SHARED_OBJDIR)/%.o: %.c $(EXTRA_LIB_DEPS) | $(SHARED_OBJDIR)
	$(QUIET_CC)$(CC) $(CFLAGS) $(CPPFLAGS) $(SHARED_CFLAGS) -Wall -I../../headers -c $< -o $@

XDP_IN_SHARED	:= $(SHARED_OBJDIR)/libxdp.o $(SHARED_OBJDIR)/xsk.o

GLOBAL_SYM_COUNT = $(shell $(READELF) -s --wide $(XDP_IN_SHARED) | \
			   cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' | \
			   sed 's/\[.*\]//' | \
			   awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {print $$NF}' | \
			   sort -u | wc -l)
VERSIONED_SYM_COUNT = $(shell $(READELF) --dyn-syms --wide $(OBJDIR)/libxdp.so | \
			      grep -Eo '[^ ]+@LIBXDP_' | cut -d@ -f1 | sort -u | wc -l)

check: $(CHECK_RULES)

check_abi: $(OBJDIR)/libxdp.so
	@if [ "$(GLOBAL_SYM_COUNT)" != "$(VERSIONED_SYM_COUNT)" ]; then	 \
		echo "Warning: Num of global symbols in $(XDP_IN_SHARED)"	 \
		     "($(GLOBAL_SYM_COUNT)) does NOT match with num of"	 \
		     "versioned symbols in $^ ($(VERSIONED_SYM_COUNT))." \
		     "Please make sure all symbols are"	 \
		     "versioned in $(VERSION_SCRIPT)." >&2;		 \
		$(READELF) -s --wide $(XDP_IN_SHARED) |			 \
		    cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' |	 \
		    sed 's/\[.*\]//' |					 \
		    awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {print $$NF}'|  \
		    sort -u > $(OUTPUT)libxdp_global_syms.tmp;		 \
		$(READELF) --dyn-syms --wide $(OUTPUT)libxdp.so |		 \
		    grep -Eo '[^ ]+@LIBXDP_' | cut -d@ -f1 |		 \
		    sort -u > $(OUTPUT)libxdp_versioned_syms.tmp; 	 \
		diff -u $(OUTPUT)libxdp_global_syms.tmp			 \
		     $(OUTPUT)libxdp_versioned_syms.tmp;		 \
		rm $(OUTPUT)libxdp_global_syms.tmp			 \
		   $(OUTPUT)libxdp_versioned_syms.tmp;			 \
		exit 1;							 \
	fi


$(TEMPLATED_SOURCES): %.c: %.c.in Makefile
	$(QUIET_M4)$(M4) $(DEFINES) $< > $@ || ( ret=$$?; rm -f $@; exit $$ret )

$(EMBEDDED_XDP_OBJS): %.embed.o: %.o
	$(QUIET_CC)$(CC) -r -nostdlib -Wl,-z,noexecstack,--format=binary $(LDFLAGS) -o $@ $<
	$(Q)$(OBJCOPY)  --rename-section .data=.rodata,alloc,load,readonly,data,contents $@

$(XDP_OBJS): %.o: %.c $(BPF_HEADERS) $(LIBMK)
	$(QUIET_CLANG)$(CLANG) -target $(BPF_TARGET) $(BPF_CFLAGS) -O2 -c -g -o $@ $<

.PHONY: man
ifeq ($(EMACS),)
man: ;
else
man: $(MAN_PAGE)
$(MAN_OBJ): README.org $(LIBMK)
	$(Q)$(EMACS) -Q --batch --find-file $< --eval "(progn (require 'ox-man)(org-man-export-to-man))"

$(MAN_PAGE): $(MAN_OBJ) $(LIBMK)
	$(QUIET_GEN)MODDATE=$$(git log -1 --pretty="format:%cI" README.org 2>/dev/null); \
		[ "$$?" -eq "0" ] && DATE=$$(date '+%B %_d, %Y' -d "$$MODDATE") || DATE=$$(date '+%B %_d, %Y'); \
		sed -e "1 s/DATE/$$DATE/" -e "1 s/VERSION/v$(TOOLS_VERSION)/" -e '1,5 s/^.SH "\([^"]\+\) - \([^"]\+\)"/.SH "NAME"\n\1 \\- \2\n.SH "SYNOPSIS"/' $< > $@

endif

.PHONY: build_tests
build_tests: $(SHARED_LIBS) $(STATIC_LIBS)
	$(Q)$(MAKE) -C $(TEST_DIR)

.PHONY: test
test: all
	$(Q)$(MAKE) -C $(TEST_DIR) run

=== lib/testing/Makefile ===
# SPDX-License-Identifier: (GPL-2.0 OR BSD-2-Clause)

TEST_TARGETS := test-tool
XDP_TARGETS := test_long_func_name xdp_drop xdp_pass xdp_adjust_tail
SCRIPTS_FILES := test_runner.sh setup-netns-env.sh run_tests.sh
XDP_OBJ_INSTALL :=

LIB_DIR = ..

include $(LIB_DIR)/common.mk

install_local::
	install -m 0755 -d $(DESTDIR)$(SCRIPTSDIR)
	install -m 0644 test_config.install.sh $(DESTDIR)$(SCRIPTSDIR)/test_config.sh
	install -m 0644 $(XDP_OBJ) $(DESTDIR)$(SCRIPTSDIR)/

=== lib/util/Makefile ===
include util.mk

LIB_DIR ?= ..

include $(LIB_DIR)/defines.mk
include $(LIBXDP_DIR)/libxdp.mk

all: $(UTIL_OBJS)

UTIL_SKEL_H = $(UTIL_BPF_OBJS:.bpf.o=.skel.h)

$(UTIL_OBJS): %.o: %.c %.h $(UTIL_SKEL_H) $(LIBMK)
	$(QUIET_CC)$(CC) $(CFLAGS) $(CPPFLAGS) -Wall -I../../headers -c -o $@ $<

clean:
	$(Q)rm -f $(UTIL_OBJS) $(UTIL_BPF_OBJS) $(UTIL_SKEL_H) *.ll

BPF_CFLAGS += -I$(HEADER_DIR) $(ARCH_INCLUDES)

$(UTIL_BPF_OBJS): %.o: %.c $(KERN_USER_H) $(BPF_HEADERS) $(LIBMK)
	$(QUIET_CLANG)$(CLANG) -target $(BPF_TARGET) $(BPF_CFLAGS) -O2 -c -g -o $@ $<

$(UTIL_SKEL_H): %.skel.h: %.bpf.o
	$(QUIET_GEN)$(BPFTOOL) gen skeleton $< name ${@:.skel.h=} > $@

=== lib/libbpf/src/Makefile ===
# SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause)

ifeq ($(V),1)
	Q =
	msg =
else
	Q = @
	msg = @printf '  %-8s %s%s\n' "$(1)" "$(2)" "$(if $(3), $(3))";
endif

LIBBPF_MAJOR_VERSION := 1
LIBBPF_MINOR_VERSION := 5
LIBBPF_PATCH_VERSION := 0
LIBBPF_VERSION := $(LIBBPF_MAJOR_VERSION).$(LIBBPF_MINOR_VERSION).$(LIBBPF_PATCH_VERSION)
LIBBPF_MAJMIN_VERSION := $(LIBBPF_MAJOR_VERSION).$(LIBBPF_MINOR_VERSION).0
LIBBPF_MAP_VERSION := $(shell grep -oE '^LIBBPF_([0-9.]+)' libbpf.map | sort -rV | head -n1 | cut -d'_' -f2)
ifneq ($(LIBBPF_MAJMIN_VERSION), $(LIBBPF_MAP_VERSION))
$(error Libbpf release ($(LIBBPF_VERSION)) and map ($(LIBBPF_MAP_VERSION)) versions are out of sync!)
endif

define allow-override
  $(if $(or $(findstring environment,$(origin $(1))),\
            $(findstring command line,$(origin $(1)))),,\
    $(eval $(1) = $(2)))
endef

$(call allow-override,CC,$(CROSS_COMPILE)cc)
$(call allow-override,LD,$(CROSS_COMPILE)ld)

TOPDIR = ..

INCLUDES := -I. -I$(TOPDIR)/include -I$(TOPDIR)/include/uapi
ALL_CFLAGS := $(INCLUDES)

SHARED_CFLAGS += -fPIC -fvisibility=hidden -DSHARED

CFLAGS ?= -g -O2 -Werror -Wall -std=gnu89
ALL_CFLAGS += $(CFLAGS) 						\
	      -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64		\
	      -Wno-unknown-warning-option -Wno-format-overflow		\
	      $(EXTRA_CFLAGS)
ALL_LDFLAGS += $(LDFLAGS) $(EXTRA_LDFLAGS)

ifdef NO_PKG_CONFIG
	ALL_LDFLAGS += -lelf -lz
else
	PKG_CONFIG ?= pkg-config
	ALL_CFLAGS += $(shell $(PKG_CONFIG) --cflags libelf zlib)
	ALL_LDFLAGS += $(shell $(PKG_CONFIG) --libs libelf zlib)
endif

OBJDIR ?= .
SHARED_OBJDIR := $(OBJDIR)/sharedobjs
STATIC_OBJDIR := $(OBJDIR)/staticobjs
OBJS := bpf.o btf.o libbpf.o libbpf_errno.o netlink.o \
	nlattr.o str_error.o libbpf_probes.o bpf_prog_linfo.o \
	btf_dump.o hashmap.o ringbuf.o strset.o linker.o gen_loader.o \
	relo_core.o usdt.o zip.o elf.o features.o btf_iter.o btf_relocate.o
SHARED_OBJS := $(addprefix $(SHARED_OBJDIR)/,$(OBJS))
STATIC_OBJS := $(addprefix $(STATIC_OBJDIR)/,$(OBJS))

STATIC_LIBS := $(OBJDIR)/libbpf.a
ifndef BUILD_STATIC_ONLY
	SHARED_LIBS := $(OBJDIR)/libbpf.so \
		       $(OBJDIR)/libbpf.so.$(LIBBPF_MAJOR_VERSION) \
		       $(OBJDIR)/libbpf.so.$(LIBBPF_VERSION)
	VERSION_SCRIPT := libbpf.map
endif

HEADERS := bpf.h libbpf.h btf.h libbpf_common.h libbpf_legacy.h \
	   bpf_helpers.h bpf_helper_defs.h bpf_tracing.h \
	   bpf_endian.h bpf_core_read.h skel_internal.h libbpf_version.h \
	   usdt.bpf.h
UAPI_HEADERS := $(addprefix $(TOPDIR)/include/uapi/linux/,\
			    bpf.h bpf_common.h btf.h)

PC_FILE := $(OBJDIR)/libbpf.pc

INSTALL = install

DESTDIR ?=

HOSTARCH = $(firstword $(subst -, ,$(shell $(CC) -dumpmachine)))
ifeq ($(filter-out %64 %64be %64eb %64le %64el s390x, $(HOSTARCH)),)
	LIBSUBDIR := lib64
else
	LIBSUBDIR := lib
endif

# By default let the pc file itself use ${prefix} in includedir/libdir so that
# the prefix can be overridden at runtime (eg: --define-prefix)
ifndef LIBDIR
	LIBDIR_PC := $$\{prefix\}/$(LIBSUBDIR)
else
	LIBDIR_PC := $(LIBDIR)
endif
PREFIX ?= /usr
LIBDIR ?= $(PREFIX)/$(LIBSUBDIR)
INCLUDEDIR ?= $(PREFIX)/include
UAPIDIR ?= $(PREFIX)/include

TAGS_PROG := $(if $(shell which etags 2>/dev/null),etags,ctags)

all: $(STATIC_LIBS) $(SHARED_LIBS) $(PC_FILE)

$(OBJDIR)/libbpf.a: $(STATIC_OBJS)
	$(call msg,AR,$@)
	$(Q)$(AR) rcs $@ $^

$(OBJDIR)/libbpf.so: $(OBJDIR)/libbpf.so.$(LIBBPF_MAJOR_VERSION)
	$(Q)ln -sf $(^F) $@

$(OBJDIR)/libbpf.so.$(LIBBPF_MAJOR_VERSION): $(OBJDIR)/libbpf.so.$(LIBBPF_VERSION)
	$(Q)ln -sf $(^F) $@

$(OBJDIR)/libbpf.so.$(LIBBPF_VERSION): $(SHARED_OBJS)
	$(call msg,CC,$@)
	$(Q)$(CC) -shared -Wl,--version-script=$(VERSION_SCRIPT) \
		  -Wl,-soname,libbpf.so.$(LIBBPF_MAJOR_VERSION) \
		  $^ $(ALL_LDFLAGS) -o $@

$(OBJDIR)/libbpf.pc: force | $(OBJDIR)
	$(Q)sed -e "s|@PREFIX@|$(PREFIX)|" \
		-e "s|@LIBDIR@|$(LIBDIR_PC)|" \
		-e "s|@VERSION@|$(LIBBPF_VERSION)|" \
		< libbpf.pc.template > $@

$(OBJDIR) $(STATIC_OBJDIR) $(SHARED_OBJDIR):
	$(call msg,MKDIR,$@)
	$(Q)mkdir -p $@

$(STATIC_OBJDIR)/%.o: %.c | $(STATIC_OBJDIR)
	$(call msg,CC,$@)
	$(Q)$(CC) $(ALL_CFLAGS) $(CPPFLAGS) -c $< -o $@

$(SHARED_OBJDIR)/%.o: %.c | $(SHARED_OBJDIR)
	$(call msg,CC,$@)
	$(Q)$(CC) $(ALL_CFLAGS) $(SHARED_CFLAGS) $(CPPFLAGS) -c $< -o $@

define do_install
	$(call msg,INSTALL,$1)
	$(Q)if [ ! -d '$(DESTDIR)$2' ]; then		\
		$(INSTALL) -d -m 755 '$(DESTDIR)$2';	\
	fi;
	$(Q)$(INSTALL) $(if $3,-m $3,) $1 '$(DESTDIR)$2'
endef

# Preserve symlinks at installation.
define do_s_install
	$(call msg,INSTALL,$1)
	$(Q)if [ ! -d '$(DESTDIR)$2' ]; then		\
		$(INSTALL) -d -m 755 '$(DESTDIR)$2';	\
	fi;
	$(Q)cp -fR $1 '$(DESTDIR)$2'
endef

install: all install_headers install_pkgconfig
	$(call do_s_install,$(STATIC_LIBS) $(SHARED_LIBS),$(LIBDIR))

install_headers:
	$(call do_install,$(HEADERS),$(INCLUDEDIR)/bpf,644)

# UAPI headers can be installed by a different package so they're not installed
# in by install rule.
install_uapi_headers:
	$(call do_install,$(UAPI_HEADERS),$(UAPIDIR)/linux,644)

install_pkgconfig: $(PC_FILE)
	$(call do_install,$(PC_FILE),$(LIBDIR)/pkgconfig,644)

clean:
	$(call msg,CLEAN)
	$(Q)rm -rf *.o *.a *.so *.so.* *.pc $(SHARED_OBJDIR) $(STATIC_OBJDIR)

.PHONY: cscope tags force
cscope:
	$(call msg,CSCOPE)
	$(Q)ls *.c *.h > cscope.files
	$(Q)cscope -b -q -f cscope.out

tags:
	$(call msg,CTAGS)
	$(Q)rm -f TAGS tags
	$(Q)ls *.c *.h | xargs $(TAGS_PROG) -a

force:

=== lib/libxdp/tests/Makefile ===
# SPDX-License-Identifier: (GPL-2.0 OR BSD-2-Clause)

USER_TARGETS := test_xsk_refcnt test_xdp_frags test_link_detach test_xsk_umem_flags
STATIC_LINK_TARGETS := check_kern_compat test_dispatcher_versions
BPF_TARGETS := xdp_dispatcher_v1 xdp_pass
USER_LIBS := -lpthread
USER_EXTRA_C := test_utils.c

EXTRA_DEPS += xdp_dispatcher_v1.h
EXTRA_USER_DEPS += test_utils.h $(USER_EXTRA_C)

TEST_FILE := ./test-libxdp.sh
TEST_RUNNER := ./test_runner.sh

LIB_DIR := ../..
LDLIBS += $(USER_LIBS)

include $(LIB_DIR)/libxdp/libxdp.mk
include $(LIB_DIR)/defines.mk

ifeq ($(HAVE_CAP_NG),y)
	USER_TARGETS += test_xsk_non_privileged
	CFLAGS += $(CAP_NG_CFLAGS)
	LDLIBS += $(CAP_NG_LDLIBS)
endif

USER_C := ${USER_TARGETS:=.c} ${STATIC_LINK_TARGETS:=.c}
USER_OBJ := ${USER_C:.c=.o}
BPF_OBJS := $(BPF_TARGETS:=.o)

LDFLAGS+=-L$(LIBXDP_DIR)
STATIC_OBJECT_LIBXDP:=$(LIBXDP_DIR)/libxdp.a
STATIC_LDLIBS:=-l:libxdp.a $(LDLIBS)
ifeq ($(DYNAMIC_LIBXDP),1)
	LDLIBS:=-lxdp $(LDLIBS)
	OBJECT_LIBXDP:=$(LIBXDP_DIR)/libxdp.so.$(LIBXDP_VERSION)
else
	LDLIBS:=$(STATIC_LDLIBS)
	OBJECT_LIBXDP:=$(STATIC_OBJECT_LIBXDP)
endif

# Detect submodule libbpf source file changes
ifeq ($(SYSTEM_LIBBPF),n)
	LIBBPF_SOURCES := $(wildcard $(LIBBPF_DIR)/src/*.[ch])
endif

LIBXDP_SOURCES := $(wildcard $(LIBXDP_DIR)/*.[ch] $(LIBXDP_DIR)/*.in)

CFLAGS += -I$(HEADER_DIR)

BPF_HEADERS := $(wildcard $(HEADER_DIR)/bpf/*.h) $(wildcard $(HEADER_DIR)/xdp/*.h)

all: $(USER_TARGETS) $(STATIC_LINK_TARGETS) $(BPF_OBJS)

.PHONY: clean
clean::
	$(Q)rm -f $(USER_TARGETS) $(USER_OBJ)

.PHONY: install
install: all
	install -m 0755 -d $(DESTDIR)$(SCRIPTSDIR)/tests/libxdp
	install -m 0644 $(TEST_FILE) $(DESTDIR)$(SCRIPTSDIR)/tests/libxdp
	install -m 0755 $(USER_TARGETS) $(STATIC_LINK_TARGETS) $(DESTDIR)$(SCRIPTSDIR)/tests/libxdp
	install -m 0644 $(BPF_OBJS) $(DESTDIR)$(SCRIPTSDIR)/tests/libxdp

$(OBJECT_LIBBPF): $(LIBBPF_SOURCES)
	$(Q)$(MAKE) -C $(LIB_DIR) libbpf

$(OBJECT_LIBXDP): $(LIBXDP_SOURCES)
	$(Q)$(MAKE) -C $(LIBXDP_DIR)

# Create expansions for dependencies
LIB_H := ${LIB_OBJS:.o=.h}

# Detect if any of common obj changed and create dependency on .h-files
$(LIB_OBJS): %.o: %.c %.h $(LIB_H)
	$(Q)$(MAKE) -C $(dir $@) $(notdir $@)

$(USER_TARGETS): %: %.c  $(OBJECT_LIBBPF) $(OBJECT_LIBXDP) $(LIBMK) $(LIB_OBJS) $(EXTRA_DEPS) $(EXTRA_USER_DEPS)
	$(QUIET_CC)$(CC) -Wall $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -o $@ $(LIB_OBJS) \
	 $< $(USER_EXTRA_C) $(LDLIBS)

$(STATIC_LINK_TARGETS): %: %.c  $(OBJECT_LIBBPF) $(STATIC_OBJECT_LIBXDP) $(LIBMK) $(LIB_OBJS) $(EXTRA_DEPS) $(EXTRA_USER_DEPS)
	$(QUIET_CC)$(CC) -Wall $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -o $@ $(LIB_OBJS) \
	 $< $(USER_EXTRA_C) $(STATIC_LDLIBS)

$(BPF_OBJS): %.o: %.c $(BPF_HEADERS) $(LIBMK) $(EXTRA_DEPS)
	$(QUIET_CLANG)$(CLANG) -target $(BPF_TARGET) $(BPF_CFLAGS) -O2 -c -g -o $@ $<

run: all
	$(Q)env CC="$(CC)" CFLAGS="$(CFLAGS) $(LDFLAGS)" CPPFLAGS="$(CPPFLAGS)" LDLIBS="$(LDLIBS)" V=$(V) $(TEST_RUNNER) $(TEST_FILE) $(RUN_TESTS)

=== debian/changelog ===
xdp-tools (1.5.7-3) unstable; urgency=medium

  * Backport patch to fix flaky tests

 -- Luca Boccassi <bluca@debian.org>  Mon, 06 Oct 2025 16:17:27 +0100

xdp-tools (1.5.7-2) unstable; urgency=medium

  * autopkgtest: add dependencies for new tests

 -- Luca Boccassi <bluca@debian.org>  Sun, 05 Oct 2025 22:21:47 +0100

xdp-tools (1.5.7-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.5.7'

 -- Luca Boccassi <bluca@debian.org>  Sun, 05 Oct 2025 13:40:43 +0100

=== debian/control ===
Source: xdp-tools
Section: devel
Priority: optional
Maintainer: Luca Boccassi <bluca@debian.org>
Rules-Requires-Root: no
Build-Depends: bpftool (>= 7.5.0~),
               clang,
               debhelper-compat (= 13),
               dh-package-notes,
               libbpf-dev,
               libelf-dev,
               libpcap-dev,
               llvm,
               pkgconf,
               zlib1g-dev,
Standards-Version: 4.7.2
Homepage: https://github.com/xdp-project/xdp-tools
Vcs-Browser: https://salsa.debian.org/debian/xdp-tools
Vcs-Git: https://salsa.debian.org/debian/xdp-tools.git

Package: libxdp1
Section: libs
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Pre-Depends: ${misc:Pre-Depends}
Description: library and utilities for use with XDP - shared library
 Library for working with the eXpress Data Path facility of the Linux kernel,
 and a collection of utilities and example code that uses the library.

Package: libxdp-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libxdp1 (= ${binary:Version}), ${misc:Depends}, libbpf-dev,
Description: library and utilities for use with XDP - development files
 Library for working with the eXpress Data Path facility of the Linux kernel,
 and a collection of utilities and example code that uses the library.
 .
 This package provides the development files for libxdp1.

Package: xdp-tools
Architecture: linux-any
Depends: libxdp1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends},
Description: library and utilities for use with XDP
 Library for working with the eXpress Data Path facility of the Linux kernel,
 and a collection of utilities and example code that uses the library.
 .
 This package provides tools for the xdp ecosystem.

Package: xdp-tests
Architecture: linux-any
Depends: xdp-tools (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends},
Description: library and utilities for use with XDP - test scripts and programs
 Library for working with the eXpress Data Path facility of the Linux kernel,
 and a collection of utilities and example code that uses the library.
 .
 This package provides tests for the xdp tools.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk
include /usr/share/debhelper/dh_package_notes/package-notes.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export PREFIX=/usr
export LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
export FORCE_SYSTEM_LIBBPF=1
export PRODUCTION=1
# For asm/types.h
export BPF_CFLAGS=-Wno-visibility -I/usr/include/$(DEB_HOST_MULTIARCH)
# Workaround for LP: #2103416
export BPF_CFLAGS+=-Wno-unused-command-line-argument
ifneq (,$(filter $(DEB_HOST_MULTIARCH), mips64el-linux-gnuabi64 mipsel-linux-gnu))
export BPF_CFLAGS+= -D__MIPSEL__=1
endif

ifneq (,$(findstring terse,$(DEB_BUILD_OPTIONS)))
export VERBOSE=0
else
export VERBOSE=1
endif

%:
	dh $@

# Tests require root and break the testbed
override_dh_auto_test:

=== debian/tests/control ===
Test-Command: /usr/libexec/xdp-tools/run_tests.sh
Restrictions: isolation-machine, needs-root, allow-stderr
Depends: xdp-tests, ethtool, iproute2, iputils-ping, netcat-openbsd, tcpdump, tshark, mount, socat, ndisc6, arping

=== debian/watch ===
version=4
opts="searchmode=plain" \
  https://api.github.com/repos/xdp-project/@PACKAGE@/releases \
  https://github.com/xdp-project/@PACKAGE@/releases/download/v(?:\d[\d.]*)/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@

## xdp-tools 1.5.8

=== debian/changelog ===
xdp-tools (1.5.8-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.5.8'
  * Drop patches, merged upstream

 -- Luca Boccassi <bluca@debian.org>  Sun, 30 Nov 2025 10:11:39 +0000

## xdp-tools 1.6.0

=== debian/changelog ===
xdp-tools (1.6.0-1ubuntu1) resolute; urgency=medium

  * Upload a fix for new gcc and new fortify flags

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 18 Feb 2026 20:35:58 +0100

xdp-tools (1.6.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.6.0'
  * Drop priority from d/control, now defaults to optional
  * Drop Rules-Requires-Root, now defaults to no
  * Bump Standards-version to 4.7.3
  * Backport patch to fix 32bit builds
  * Update symbols file for 1.6.0

 -- Luca Boccassi <bluca@debian.org>  Sat, 10 Jan 2026 12:13:15 +0100

## xdp-tools 1.6.1

=== xdp-bench/Makefile ===
--- 
+++ 
@@ -12,7 +12,7 @@
 TEST_FILE := tests/test-xdp-bench.sh
 USER_TARGETS := xdp-bench
 USER_EXTRA_C := xdp_redirect_basic.c xdp_redirect_cpumap.c xdp_redirect_devmap.c \
-		xdp_redirect_devmap_multi.c xdp_basic.c
+		xdp_redirect_devmap_multi.c xdp_basic.c xdp_socket.c
 EXTRA_USER_DEPS := xdp-bench.h
 
 LIB_DIR       = ../lib

=== debian/changelog ===
xdp-tools (1.6.1-1ubuntu2) resolute; urgency=medium

  * Backport new version of upstream 554.patch

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 19 Feb 2026 14:03:55 +0100

xdp-tools (1.6.1-1) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Add an upstrea-proposed patch to fix build when stringop-overread
    gcc flag is used

  [ Luca Boccassi ]
  * Fix watch file to find release tags
  * Update upstream source from tag 'upstream/1.6.1'
  * Drop 0001-lib-xdpsock-fix-32bit-builds.patch, merged upstream
  * Adjust DEP-3 header in 554.patch
  * Add patch to fix make clean to remove all built objects (Closes:
    #1046253)
  * Backport patch to fix 32bit build
  * Update d/copyright for removed files

 -- Luca Boccassi <bluca@debian.org>  Wed, 18 Feb 2026 23:53:17 +0000

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,6 @@
 Source: xdp-tools
 Section: devel
-Priority: optional
 Maintainer: Luca Boccassi <bluca@debian.org>
-Rules-Requires-Root: no
 Build-Depends: bpftool (>= 7.5.0~),
                clang,
                debhelper-compat (= 13),
@@ -13,7 +11,7 @@
                llvm,
                pkgconf,
                zlib1g-dev,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://github.com/xdp-project/xdp-tools
 Vcs-Browser: https://salsa.debian.org/debian/xdp-tools
 Vcs-Git: https://salsa.debian.org/debian/xdp-tools.git

## xdp-tools 1.6.2

=== Makefile ===
--- 
+++ 
@@ -72,6 +72,7 @@
 clean: check_submodule
 	@for i in $(SUBDIRS); \
 	do $(MAKE) -C $$i clean; done
+	rm -f config.mk
 
 install: all
 	@for i in $(SUBDIRS); \

=== xdp-trafficgen/Makefile ===
# SPDX-License-Identifier: (GPL-2.0 OR BSD-2-Clause)

XDP_TARGETS  := xdp_trafficgen.bpf
BPF_SKEL_TARGETS := $(XDP_TARGETS)

# Don't install skeleton object files
XDP_OBJ_INSTALL :=

TOOL_NAME := xdp-trafficgen
USER_TARGETS := xdp-trafficgen
MAN_PAGE := xdp-trafficgen.8
EXTRA_DEPS := xdp-trafficgen.h
TEST_FILE := tests/test-xdp-trafficgen.sh

LIB_DIR = ../lib

include $(LIB_DIR)/common.mk

=== lib/libxdp/tests/Makefile ===
--- 
+++ 
@@ -1,12 +1,12 @@
 # SPDX-License-Identifier: (GPL-2.0 OR BSD-2-Clause)
 
-USER_TARGETS := test_xsk_refcnt test_xdp_frags test_link_detach test_xsk_umem_flags
+USER_TARGETS := test_xsk_refcnt test_xdp_frags test_link_detach test_xsk_umem_flags test_xdp_devbound
 STATIC_LINK_TARGETS := check_kern_compat test_dispatcher_versions
-BPF_TARGETS := xdp_dispatcher_v1 xdp_pass
+BPF_TARGETS := xdp_dispatcher_v1 xdp_dispatcher_v2 xdp_pass
 USER_LIBS := -lpthread
 USER_EXTRA_C := test_utils.c
 
-EXTRA_DEPS += xdp_dispatcher_v1.h
+EXTRA_DEPS += xdp_dispatcher.h
 EXTRA_USER_DEPS += test_utils.h $(USER_EXTRA_C)
 
 TEST_FILE := ./test-libxdp.sh
@@ -54,7 +54,7 @@
 
 .PHONY: clean
 clean::
-	$(Q)rm -f $(USER_TARGETS) $(USER_OBJ)
+	$(Q)rm -f $(USER_TARGETS) $(USER_OBJ) $(STATIC_LINK_TARGETS) $(BPF_OBJS)
 
 .PHONY: install
 install: all

=== debian/changelog ===
xdp-tools (1.6.2-1) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Backport new version of upstream 554.patch
  * Another patch refresh from upstream codereview

  [ Luca Boccassi ]
  * Update upstream source from tag 'upstream/1.6.2'
  * Drop patches, all merged upstream

 -- Luca Boccassi <bluca@debian.org>  Mon, 23 Feb 2026 22:24:18 +0000
